/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.ldt.bills.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.core.tool.utils.ObjectUtil;
import org.springblade.ldt.bills.entity.GoodsBills;
import org.springblade.ldt.bills.service.IGoodsBillsService;
import org.springblade.ldt.bills.vo.GoodsBillsVO;
import org.springblade.ldt.bills.wrapper.GoodsBillsWrapper;
import org.springblade.ldt.shop.entity.Shop;
import org.springblade.ldt.shop.service.IShopService;
import org.springblade.ldt.user.entity.LoginUser;
import org.springblade.ldt.user.service.ILoginUserService;
import org.springframework.web.bind.annotation.*;

import javax.validation.Valid;

/**
 * 订单 控制器
 *
 * @author BladeX
 * @since 2021-09-26
 */
@RestController
@AllArgsConstructor
@RequestMapping("ldt_bills/goodsbills")
@Api(value = "订单", tags = "订单接口")
public class GoodsBillsController extends BladeController {

	private final IGoodsBillsService goodsBillsService;
	private final ILoginUserService userService;
	private final IShopService shopService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入goodsBills")
	public R<GoodsBillsVO> detail(GoodsBills goodsBills) {
		//GoodsBills detail = goodsBillsService.getOne(Condition.getQueryWrapper(goodsBills));
		GoodsBillsVO detail = GoodsBillsWrapper.build().entityVO(goodsBillsService.getOne(Condition.getQueryWrapper(goodsBills)));
		searchUserInfo(detail);
		return R.data(detail);
	}

	/**
	 * 接收人和付款人信息
	 *
	 * @param detail
	 */
	private void searchUserInfo(GoodsBillsVO detail) {
		LoginUser user = userService.getById(detail.getPayId());
		if (ObjectUtil.isNotEmpty(user)) {
			detail.setPayer(user.getNickName());
		}
		Shop shop = shopService.getById(detail.getReceiveId());
		if (ObjectUtil.isNotEmpty(shop)) {
			detail.setTaker(shop.getName());
		}
	}

	/**
	 * 分页 订单
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入goodsBills")
	public R<IPage<GoodsBillsVO>> list(GoodsBills goodsBills, Query query) {
		//IPage<GoodsBills> pages = goodsBillsService.page(Condition.getPage(query), Condition.getQueryWrapper(goodsBills));
		IPage<GoodsBillsVO> pages = GoodsBillsWrapper.build().pageVO(goodsBillsService.page(Condition.getPage(query), Condition.getQueryWrapper(goodsBills)));
		pages.getRecords().forEach(this::searchUserInfo);
		return R.data(pages);
	}


	/**
	 * 自定义分页 订单
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入goodsBills")
	public R<IPage<GoodsBillsVO>> page(GoodsBillsVO goodsBills, Query query) {
		IPage<GoodsBillsVO> pages = goodsBillsService.selectGoodsBillsPage(Condition.getPage(query), goodsBills);
		return R.data(pages);
	}

	/**
	 * 新增 订单
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入goodsBills")
	public R save(@Valid @RequestBody GoodsBills goodsBills) {
		return R.status(goodsBillsService.save(goodsBills));
	}

	/**
	 * 修改 订单
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入goodsBills")
	public R update(@Valid @RequestBody GoodsBills goodsBills) {
		return R.status(goodsBillsService.updateById(goodsBills));
	}

	/**
	 * 新增或修改 订单
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入goodsBills")
	public R submit(@Valid @RequestBody GoodsBills goodsBills) {
		return R.status(goodsBillsService.saveOrUpdate(goodsBills));
	}


	/**
	 * 删除 订单
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(goodsBillsService.deleteLogic(Func.toLongList(ids)));
	}


}
